//
// Created by jedi on 10/30/18.
//

#include "ssd1306.h"
#include "nano_gfx.h"
#include <stdlib.h>

uint8_t canvasData[SCREEN_WIDTH*(SCREEN_HEIGHT/8)];
NanoCanvas canvas(SCREEN_WIDTH, SCREEN_HEIGHT, canvasData);

void hal_init(){
    ssd1306_128x32_i2c_init();
    ssd1306_fillScreen( 0x00 );
    canvas.clear();
}

void hal_draw(int x, int y){
    canvas.putPixel(x, y);
}

void hal_render() {

    DDRD = 0;
    PORTD |= (1 << PC2)|(1 << PC3)|(1 << PC4)|(1 << PC5);

    while (1) {
        int in = PIND & 0x3c;

        input[0]=in & (1<<PC2);
        input[1]=in & (1<<PC3);
        input[2]=in & (1<<PC4);
        input[3]=in & (1<<PC5);

        canvas.clear();
        render();
        canvas.blt(0, 0);
    }
}

void * operator new(unsigned int size)
{
    return malloc(size);
}

void operator delete(void * ptr)
{
    free(ptr);
}

void debug(const char* str){
    //TODO implement
}